def default_format(ins):
    """default formatter for dis(o)"""
    def d2h(i):
        return "%02X" % i

    jumpto = ""
    if ins.jumpTo != None:
        jumpto = "-> %s" % ins.jumpTo


    argstr = ""
    if ins.argstr != None:
        argstr = "(%s)" % ins.argstr

    return "%5s %5d %8s %s%s %s" % (
            ins.is_line_start and str(ins.line_no) or " ",
            ins.pos,
            ",".join(map(d2h, ins.value)),
            ins.opname,
            argstr,
            jumpto)

def dis(o, format=default_format):
    """dis(o) --- a shortcut like dis.dis
    print instructions pretty
    """
    from co2insts import co2insts
    from get_co import get_co
    co = get_co(o)
    insts = co2insts(co)
    for ins in insts:
        print format(ins)

    return insts
