from opcode import hasjrel, hasjabs, HAVE_ARGUMENT
from instruction import Instruction

def co2insts(cobj):
    """from a code-object to a list of Instructions"""

    def get_length_of_inst(op):
        if op < HAVE_ARGUMENT:
            return 1
        return 3

    # get a mapping from byte offset and line number
    from dis import findlinestarts
    line_no_map = dict(findlinestarts(cobj))

    result = []
    code = map(ord, cobj.co_code)
    
    i = 0

    while code[i:]:
        c = code[i]
        n = get_length_of_inst(c)

        inst = Instruction(code[i:i+n], cobj)
        result.append(inst)
        inst.pos = i

        if c in hasjrel:
            inst.jumpTo = i + 3 + inst.arg
        elif c in hasjabs:
            inst.jumpTo = inst.arg

        if i in line_no_map:
            inst.is_line_start = True
            current_line_no = line_no_map[i]
        inst.line_no = current_line_no
        
        i += n

    return result

